Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.session
Class JDBCStore

    java.lang.Object
      |
      +--org.apache.catalina.session.StoreBase
            |
            +--org.apache.catalina.session.JDBCStore

public class JDBCStore
extends StoreBase
implements Store

Implementation of the `Store` interface that stores serialized session objects in a database. Sessions that are saved are still subject to being expired based on inactivity.

Version:
  $Revision: 1.4.2.1 $, $Date: 2002/04/17 17:08:48 $
Author:
  Bip Thelin

Field Summary
`protected java.lang.String` | `connString` Connection string to use when connecting to the DB.
`protected java.lang.String` | `driverName` Driver to use.
`protected static java.lang.String` | `info` The descriptive information about this implementation.
`protected java.sql.PreparedStatement` | `preparedClearSql` Variable to hold the `clear()` prepared statement.
`protected java.sql.PreparedStatement` | `preparedKeysSql` Variable to hold the `keys()` prepared statement.
`protected java.sql.PreparedStatement` | `preparedLoadSql` Variable to hold the `load()` prepared statement.
`protected java.sql.PreparedStatement` | `preparedRemoveSql` Variable to hold the `remove()` prepared statement.
`protected java.sql.PreparedStatement` | `preparedSaveSql` Variable to hold the `save()` prepared statement.
`protected java.sql.PreparedStatement` | `preparedSizeSql` Variable to hold the `getSize()` prepared statement.
`protected java.lang.String` | `sessionDataCol` Data column to use.
`protected java.lang.String` | `sessionIdCol` Id column to use.
`protected java.lang.String` | `sessionLastAccessedCol` Last Accessed column to use.
`protected java.lang.String` | `sessionMaxInactiveCol` Max Inactive column to use.
`protected java.lang.String` | `sessionTable` Table to use.
`protected java.lang.String` | `sessionValidCol` Is Valid column to use.
`protected static java.lang.String` | `storeName` Name to register for this Store, used for logging.
`protected java.lang.String` | `threadName` Name to register for the background thread.

Fields inherited from class org.apache.catalina.session.StoreBase
`checkInterval, debug, info, lifecycle, manager, sm, started, storeName, support, thread, threadDone, threadName`

Constructor Summary
`JDBCStore()`

Method Summary
`void` | `clear()` Remove all of the Sessions in this Store.
`protected java.sql.Connection` | `getConnection()` Check the connection associated with this store, if it's `null` or closed try to reopen it.
`java.lang.String` | `getConnectionURL()` Return the Connection URL for this Store.
`java.lang.String` | `getDriverName()` Return the driver for this Store.
`java.lang.String` | `getInfo()` Return the info for this Store.
`java.lang.String` | `getSessionDataCol()` Return the data column for the table
`java.lang.String` | `getSessionIdCol()` Return the Id column for the table.
`java.lang.String` | `getSessionLastAccessedCol()` Return the Last Accessed column
`java.lang.String` | `getSessionMaxInactiveCol()` Return the Max Inactive column
`java.lang.String` | `getSessionTable()` Return the table for this Store.
`java.lang.String` | `getSessionValidCol()` Return the Is Valid column
`int` | `getSize()` Return an integer containing a count of all Sessions currently saved in this Store.
`java.lang.String` | `getStoreName()` Return the name for this Store, used for logging.
`java.lang.String` | `getThreadName()` Return the thread name for this Store.
`java.lang.String[]` | `keys()` Return an array containing the session identifiers of all Sessions currently saved in this Store.
`Session` | `load(java.lang.String id)` Load the Session associated with the id `id`.
`protected void` | `release(java.sql.Connection conn)` Release the connection, not needed here since the connection is not associated with a connection pool.
`void` | `remove(java.lang.String id)` Remove the Session with the specified session identifier from this Store, if present.
`void` | `save(Session session)` Save a session to the Store.
`void` | `setConnectionURL(java.lang.String connectionURL)` Set the Connection URL for this Store.
`void` | `setDriverName(java.lang.String driverName)` Set the driver for this Store.
`void` | `setSessionDataCol(java.lang.String sessionDataCol)` Set the Data column for the table
`void` | `setSessionIdCol(java.lang.String sessionIdCol)` Set the Id column for the table.
`void` | `setSessionLastAccessedCol(java.lang.String sessionLastAccessedCol)` Set the Last Accessed column for the table
`void` | `setSessionMaxInactiveCol(java.lang.String sessionMaxInactiveCol)` Set the Max Inactive column for the table
`void` | `setSessionTable(java.lang.String sessionTable)` Set the table for this Store.
`void` | `setSessionValidCol(java.lang.String sessionValidCol)` Set the Is Valid column for the table
`void` | `start()` Called once when this Store is first started.
`void` | `stop()` Gracefully terminate everything associated with our db.

Methods inherited from class org.apache.catalina.session.StoreBase
`addLifecycleListener, addPropertyChangeListener, getCheckInterval, getDebug, getManager, log, processExpires, removeLifecycleListener, removePropertyChangeListener, run, setCheckInterval, setDebug, setManager, threadSleep, threadStart, threadStop`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### info

    protected static java.lang.String info

  The descriptive information about this implementation.

### storeName

    protected static java.lang.String storeName

  Name to register for this Store, used for logging.

### threadName

    protected java.lang.String threadName

  Name to register for the background thread.

### connString

    protected java.lang.String connString

  Connection string to use when connecting to the DB.

### driverName

    protected java.lang.String driverName

  Driver to use.

### sessionTable

    protected java.lang.String sessionTable

  Table to use.

### sessionIdCol

    protected java.lang.String sessionIdCol

  Id column to use.

### sessionDataCol

    protected java.lang.String sessionDataCol

  Data column to use.

### sessionValidCol

    protected java.lang.String sessionValidCol

  Is Valid column to use.

### sessionMaxInactiveCol

    protected java.lang.String sessionMaxInactiveCol

  Max Inactive column to use.

### sessionLastAccessedCol

    protected java.lang.String sessionLastAccessedCol

  Last Accessed column to use.

### preparedSizeSql

    protected java.sql.PreparedStatement preparedSizeSql

  Variable to hold the `getSize()` prepared statement.

### preparedKeysSql

    protected java.sql.PreparedStatement preparedKeysSql

  Variable to hold the `keys()` prepared statement.

### preparedSaveSql

    protected java.sql.PreparedStatement preparedSaveSql

  Variable to hold the `save()` prepared statement.

### preparedClearSql

    protected java.sql.PreparedStatement preparedClearSql

  Variable to hold the `clear()` prepared statement.

### preparedRemoveSql

    protected java.sql.PreparedStatement preparedRemoveSql

  Variable to hold the `remove()` prepared statement.

### preparedLoadSql

    protected java.sql.PreparedStatement preparedLoadSql

  Variable to hold the `load()` prepared statement.

Constructor Detail

### JDBCStore

    public JDBCStore()

Method Detail

### getInfo

    public java.lang.String getInfo()

  Return the info for this Store.
  Specified by:
    getInfo in interface Store
  Overrides:
    getInfo in class StoreBase

### getThreadName

    public java.lang.String getThreadName()

  Return the thread name for this Store.
  Overrides:
    getThreadName in class StoreBase

### getStoreName

    public java.lang.String getStoreName()

  Return the name for this Store, used for logging.
  Overrides:
    getStoreName in class StoreBase

### setDriverName

    public void setDriverName(java.lang.String driverName)

  Set the driver for this Store.
  Parameters:
    `driverName` - The new driver

### getDriverName

    public java.lang.String getDriverName()

  Return the driver for this Store.

### setConnectionURL

    public void setConnectionURL(java.lang.String connectionURL)

  Set the Connection URL for this Store.
  Parameters:
    `connectionURL` - The new Connection URL

### getConnectionURL

    public java.lang.String getConnectionURL()

  Return the Connection URL for this Store.

### setSessionTable

    public void setSessionTable(java.lang.String sessionTable)

  Set the table for this Store.
  Parameters:
    `sessionTable` - The new table

### getSessionTable

    public java.lang.String getSessionTable()

  Return the table for this Store.

### setSessionIdCol

    public void setSessionIdCol(java.lang.String sessionIdCol)

  Set the Id column for the table.
  Parameters:
    `sessionIdCol` - the column name

### getSessionIdCol

    public java.lang.String getSessionIdCol()

  Return the Id column for the table.

### setSessionDataCol

    public void setSessionDataCol(java.lang.String sessionDataCol)

  Set the Data column for the table
  Parameters:
    `sessionDataCol` - the column name

### getSessionDataCol

    public java.lang.String getSessionDataCol()

  Return the data column for the table

### setSessionValidCol

    public void setSessionValidCol(java.lang.String sessionValidCol)

  Set the Is Valid column for the table
  Parameters:
    `sessionValidCol` - The column name

### getSessionValidCol

    public java.lang.String getSessionValidCol()

  Return the Is Valid column

### setSessionMaxInactiveCol

    public void setSessionMaxInactiveCol(java.lang.String sessionMaxInactiveCol)

  Set the Max Inactive column for the table
  Parameters:
    `sessionMaxInactiveCol` - The column name

### getSessionMaxInactiveCol

    public java.lang.String getSessionMaxInactiveCol()

  Return the Max Inactive column

### setSessionLastAccessedCol

    public void setSessionLastAccessedCol(java.lang.String sessionLastAccessedCol)

  Set the Last Accessed column for the table
  Parameters:
    `sessionLastAccessedCol` - The column name

### getSessionLastAccessedCol

    public java.lang.String getSessionLastAccessedCol()

  Return the Last Accessed column

### keys

    public java.lang.String[] keys()
                            throws java.io.IOException

  Return an array containing the session identifiers of all Sessions currently saved in this Store. If there are no such Sessions, a zero-length array is returned.
  Specified by:
    keys in interface Store
  Throws:
    java.io.IOException - if an input/output error occurred

### getSize

    public int getSize()
                throws java.io.IOException

  Return an integer containing a count of all Sessions currently saved in this Store. If there are no Sessions, `0` is returned.
  Specified by:
    getSize in interface Store
  Throws:
    java.io.IOException - if an input/output error occurred

### load

    public Session load(java.lang.String id)
                 throws java.lang.ClassNotFoundException,
                        java.io.IOException

  Load the Session associated with the id `id`. If no such session is found `null` is returned.
  Specified by:
    load in interface Store
  Parameters:
    `id` - a value of type `String`
  Returns:
    the stored `Session`
  Throws:
    java.lang.ClassNotFoundException - if an error occurs
    java.io.IOException - if an input/output error occurred

### remove

    public void remove(java.lang.String id)
                throws java.io.IOException

  Remove the Session with the specified session identifier from this Store, if present. If no such Session is present, this method takes no action.
  Specified by:
    remove in interface Store
  Parameters:
    `id` - Session identifier of the Session to be removed
  Throws:
    java.io.IOException - if an input/output error occurs

### clear

    public void clear()
               throws java.io.IOException

  Remove all of the Sessions in this Store.
  Specified by:
    clear in interface Store
  Throws:
    java.io.IOException - if an input/output error occurs

### save

    public void save(Session session)
              throws java.io.IOException

  Save a session to the Store.
  Specified by:
    save in interface Store
  Parameters:
    `session` - the session to be stored
  Throws:
    java.io.IOException - if an input/output error occurs

### getConnection

    protected java.sql.Connection getConnection()

  Check the connection associated with this store, if it's `null` or closed try to reopen it. Returns `null` if the connection could not be established.
  Returns:
    `Connection` if the connection suceeded

### release

    protected void release(java.sql.Connection conn)

  Release the connection, not needed here since the connection is not associated with a connection pool.
  Parameters:
    `conn` - The connection to be released

### start

    public void start()
               throws LifecycleException

  Called once when this Store is first started.
  Overrides:
    start in class StoreBase
  Tags copied from class: StoreBase
  Throws:
    java.lang.IllegalStateException - if this component has already been started
    LifecycleException - if this component detects a fatal error that prevents this component from being used

### stop

    public void stop()
              throws LifecycleException

  Gracefully terminate everything associated with our db. Called once when this Store is stoping.
  Overrides:
    stop in class StoreBase
  Tags copied from class: StoreBase
  Throws:
    java.lang.IllegalStateException - if this component has not been started
    LifecycleException - if this component detects a fatal error that needs to be reported

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2001 Apache Software Foundation. All Rights Reserved.